<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<!-- 
Licensed Materials - Property of IBM
5725-C97
Copyright IBM Corporation 2011, 2012. All Rights Reserved.
US Government Users Restricted Rights- Use, duplication or disclosure
restricted by GSA ADP Schedule Contract with IBM Corp.
 -->
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>
<%@ page import="com.lombardisoftware.utility.env.ResourceEnvironmentUtils" %>
<%@ page import="java.util.logging.Level" %>
<%@ page import="java.util.logging.Logger" %>
<%@ page import="com.lombardisoftware.core.config.TWConfiguration" %>
<%@ page import="com.lombardisoftware.core.config.server.PortalConfig" %>
<%@ page import="java.util.Map" %>
<%!
	final String FILE_NAME = "index.jsp";
	final Logger log = Logger.getLogger(FILE_NAME);
%>
<%
ResourceEnvironmentUtils utils = new ResourceEnvironmentUtils();
//String isDebug = utils.getProperty("Mashups_ConfigService", "isDebug");
Map<String, String> props = null;

try {
	props = utils.getProperties("Mashups_ConfigService", "[allowClientSideLogging,available.locales,com.ibm.bspace.configuration.env,com.ibm.bpm.coach.client.debugTrace,isDebug,com.ibm.mashups.proxy.url,com.ibm.bpm.social.enableRunInFrame]");	
} catch(Exception e) {
	log.log(Level.SEVERE, "Exception Encountered from ResourceEnvironmentUtils", e);
}
String availableLocales = null;
String isDebug = null;
String configurationEnv = null;
String debugTrace = null;
String proxyURL = null;
String loggingAllowed = null;
String enableRunInFrame = null;

//display the logging widget only if the query parameter logging equals true and the server-side variable allowClientSideLogging equals true
String isLogging = "false";

if(props != null) {
	debugTrace = props.get("com.ibm.bpm.coach.client.debugTrace");
	isDebug = props.get("isDebug");
	configurationEnv = props.get("com.ibm.bspace.configuration.env");
	availableLocales = props.get("available.locales");
	proxyURL = props.get("com.ibm.mashups.proxy.url");
	loggingAllowed = props.get("allowClientSideLogging");
	enableRunInFrame = props.get("com.ibm.bpm.social.enableRunInFrame");
}

//config defaults in the event of an error?

String dojoJsFile="/mum/js/bluedojo/161/dojo/dojo.js";
if(isDebug == null || isDebug == "NULL") { 
	isDebug = "false"; 
} else if(isDebug.toLowerCase().trim().equals("true")) { 
	dojoJsFile="/mum/js/bluedojo/161/dojo/dojo.js.uncompressed.js";
}

if(availableLocales == null || availableLocales.equals("NULL")) {
	availableLocales = "fr,de,it,zh,zh-tw,es,pt-br,ja,ko,ar,he,iw,el,tr,hu,cs,ru,pl,ro,da,fi,nb,nl,no,sk,sv,ROOT";
}
if(configurationEnv == null || configurationEnv.equals("NULL")) {
	configurationEnv = "bpm_std";
}
if(proxyURL == null || proxyURL.equals("NULL")) {
	proxyURL = "/mum/proxy";
}
if(debugTrace == null || debugTrace.equals("NULL")) {
	debugTrace = "none";
}

if(enableRunInFrame == null || enableRunInFrame.equals("NULL")) {
	enableRunInFrame = "false";
}
if(loggingAllowed != null && loggingAllowed.toLowerCase().trim().equals("true")) {
	String requestForLogging = request.getParameter("logging");
	if(requestForLogging != null && (requestForLogging.toLowerCase().trim().equals("true") || requestForLogging.trim().equals("1"))) {
		isLogging = "true";
	}
}

PortalConfig portalConfig = TWConfiguration.getInstance().getServer().getPortal();

%>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en" xml:lang="en">
<head>
<meta http-equiv="X-UA-Compatible" content="IE=9; IE=8" />
<title>Process Portal</title>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
<meta http-equiv="X-UA-Compatible" content="IE=9; IE=8" />
<meta name="apple-mobile-web-app-capable" content="yes" />
<meta name = "viewport" content = "width = device-width, initial-scale = 1.0, minimum-scale = 1.0" />

<script type="text/javascript">

var portalConfigLogoutExitPage="<%=portalConfig.getCustomLogoutPage()%>";

function createXmlHttpObject() {
	var xmlhttp = null;
	if(!! window.ActiveXObject) { // same as typeof window.ActiveXObject !== "undefined"
		xmlhttp = new ActiveXObject('MSXML2.XMLHTTP.3.0');
	}
	else if(!! window.XMLHttpRequest) {
		xmlhttp = new XMLHttpRequest();
	}
	else throw Error("Browser does not support XHR.");

	return xmlhttp;
}

var myLocale = null;
var xmlhttp = createXmlHttpObject();
window.userProfile = {};
window.defaultValuesToBeUpdated = {};

if(xmlhttp!=null){
	xmlhttp.onreadystatechange=function() {
		if (xmlhttp.readyState==4 && xmlhttp.status==200){
			var resp = xmlhttp.responseText;
			var userData = JSON.parse(resp);
        	var tempUserProfile = userData.data;

        	// Since if property has not been set, the property will not be returned by REST
        	// We need to test each one and set the default if necessary.
        	if (!tempUserProfile['emailAddress']) {
        		tempUserProfile['emailAddress'] = '';
        		// Task email address is actually emailAddress from REST return
        		tempUserProfile.userPreferences['Task Email Address'] = '';
        	}
        	if (!(tempUserProfile.userPreferences['Show Unfollow Messages'])) {
        		tempUserProfile.userPreferences['Show Unfollow Messages'] = "true";
				window.defaultValuesToBeUpdated['Show Unfollow Messages'] = "true";
        	}
        	if (!(tempUserProfile.userPreferences['Portal Notification New Task To Me'])) {
        		tempUserProfile.userPreferences['Portal Notification New Task To Me'] = "true";
				window.defaultValuesToBeUpdated['Portal Notification New Task To Me'] = "true";
        	}
        	if (!(tempUserProfile.userPreferences['Task Notification'])) {
        		tempUserProfile.userPreferences['Task Notification'] = "false";
        	}
        	if (!(tempUserProfile.userPreferences['Portal Notification Post Mention'])) {
        		tempUserProfile.userPreferences['Portal Notification Post Mention'] = "true";
				window.defaultValuesToBeUpdated['Portal Notification Post Mention'] = "true";
        	}
        	if (!(tempUserProfile.userPreferences['Alert On Assign And Run'])) {
        		tempUserProfile.userPreferences['Alert On Assign And Run'] = "true";
				window.defaultValuesToBeUpdated['Alert On Assign And Run'] = "true";
        	}
        	if (!(tempUserProfile.userPreferences['Portal Notification New Task To My Group'])) {
        		tempUserProfile.userPreferences['Portal Notification New Task To My Group'] = "false";
        	}
        	if (!(tempUserProfile.userPreferences['Title'])) {
        		tempUserProfile.userPreferences['Title'] = '';
        	}
        	if (!(tempUserProfile.userPreferences['Locale'])) {
        		tempUserProfile.userPreferences['Locale'] = '';
        	}
        	if (!(tempUserProfile.userPreferences['Phone Number'])) {
        		tempUserProfile.userPreferences['Phone Number'] = '';
        	}
        	if (!(tempUserProfile.userPreferences['Calendar Type'])) {
        		tempUserProfile.userPreferences['Calendar Type'] = '';
        	}
            if (!(tempUserProfile.userPreferences['Base Text Direction'])) {
                tempUserProfile.userPreferences['Base Text Direction'] = '';
            }
        	window.userProfile._userProfile = tempUserProfile;			
			
			var pattern = /\"Locale\"\:\"(.*?)\"(\,|\})/;
			var bits = resp.match(pattern);
			if(bits!=null && bits.length > 1){
				var lcl = bits[1];
				if(typeof(lcl)!="undefined"){
					window.myLocale = lcl.replace(/_/, '-').replace(/iw/, 'he').toLowerCase();
				}
			}
		}
	};

	var nocache = (new Date()).getTime();
	xmlhttp.open("GET","/rest/bpm/wle/v1/user/current?parts=all&preventCache="+nocache,false);
	xmlhttp.setRequestHeader("Content-type","application/json");
	xmlhttp.setRequestHeader("Accept","application/json");
	xmlhttp.send();
}
window.coach = {};
window.coach.client = {};
com = {};
com.ibm = {};
com.ibm.bspace = {};
com.ibm.bspace.configuration = {};

//set the globals with the environment variables
window.isDebug = <%=isDebug%>;
window.availableLocales = "<%=availableLocales%>";
com.ibm.bspace.configuration.env = "<%=configurationEnv%>";
window.coach.client.debugTrace = "<%=debugTrace%>";
window.MASHUPS_PROXY_URL = "<%=proxyURL%>";

dojoConfig = {
		"parseOnLoad": true,
		"useGfxLayout": true,
		"gfxRenderer": "svg,silverlight,vml,canvas",
		"extraLocale": ["en"],
		"isDebug": <%=isDebug%>
};

if(myLocale!=null){
	dojoConfig.locale = myLocale;
}

djConfig = dojoConfig;
</script>
    
<script type="text/javascript">
	//Ensures timezone cookie is set, which allows old portal resources like dashboards
	//to work correctly.
	function SetTimezoneCookie() {
		var theCookie = "ibm.bpm.timezoneOffset="+escape(new Date().getTimezoneOffset())+"; path=/; ";
		document.cookie = theCookie+document.cookie;
	}
	function ReadTimezoneCookie() {
		var theCookie=""+document.cookie;
		var ind=theCookie.indexOf("ibm.bpm.timezoneOffset");
		if (ind==-1) return "";
		var ind1=theCookie.indexOf(';',ind);
		if (ind1==-1) ind1=theCookie.length;
		return unescape(theCookie.substring(ind+"ibm.bpm.timezoneOffset".length+1,ind1));
	}
	try {
		var theCookie = ReadTimezoneCookie();
		if(theCookie == null || theCookie == "") {
			SetTimezoneCookie();
		}
		var timezoneOffset = parseInt(theCookie);
		if(timezoneOffset == null || isNaN(timezoneOffset)) {
			SetTimezoneCookie();
		}
	} catch(ex) {
		SetTimezoneCookie();
	}
</script>
	
<!--  Embed JavaScript files inline to avoid extra HTTP requests -->

<!--[if IE 6]>
<script type="text/javascript">document.getElementsByTagName("html")[0].className+=" lotusui_ie lotusui_ie6";</script>
<![endif]--> 
<!--[if IE 7]>
<script type="text/javascript">document.getElementsByTagName("html")[0].className+=" lotusui_ie lotusui_ie7";</script>
<![endif]--> 
<!--[if IE 8]>
<script type="text/javascript">document.getElementsByTagName("html")[0].className+=" lotusui_ie8";</script>
<![endif]-->

<link rel="stylesheet" href="/mum/js/bluedojo/161/dijit/themes/tundra/tundra.css" type="text/css" />

<!-- We could use optimization here, but that can be revisited once the transition off of /mum/enabler has been stabilized -->
<link rel="stylesheet" href="/mum/js/bluedojo/161/dijit/themes/tundra/tundra_rtl.css" type="text/css" />

<link href="/mum/mycontenthandler/mm/dav/filestore/public/themes/processPortalTheme/img/favicon.ico" rel="shortcut icon" type="image/x-icon" />
<link href="/mum/mycontenthandler/mm/dav/filestore/public/themes/processPortalTheme/img/favicon.ico" rel="icon" type="image/x-icon" />

<script type="text/javascript" src="<%=dojoJsFile%>" charset="UTF-8"></script>

<script type="text/javascript">
//fix runtime error with dojo_build: Error: Bundle not found: islamic in dojo.cldr , locale=en
dojo.requireLocalization("dojo.cldr","islamic");

//create debug namespace
if(!com) { var com = new Object(); }
if(!com.ibm) { com.ibm = new Object(); }
if(!com.ibm.bpm) { com.ibm.bpm = new Object(); }
if(!com.ibm.bpm.social) { com.ibm.bpm.social = new Object(); }
if(!com.ibm.bpm.social.debug) { com.ibm.bpm.social.debug = new Object(); }

//declare debug variables and functions
com.ibm.bpm.social.debug._logs = new Array();
com.ibm.bpm.social.debug.isLogging = <%=isLogging%>;
com.ibm.bpm.social.debug.MESSAGE_LOGGED_TOPIC = "MESSAGE_LOGGED_TO_CONSOLE";
com.ibm.bpm.social.debug.NUM_DEPTH_OF_OBJECT_ATTRS_TO_LOG = 2;
com.ibm.bpm.social.debug.NUM_BREADTH_OF_OBJECT_ATTRS_TO_LOG = 5;
com.ibm.bpm.social.debug._stringReprOfObject = function(obj, lvl) {
	var type, str, i, key, objClass, numKeys;
	
	if(typeof(lvl) === 'undefined') {
		lvl = 0;
	}
	
	//trivial cases
	type = typeof(obj);
	if(type == "undefined") { return "undefined"; }
	if(obj == null) { return "null"; }
	if(type == "string") { return "\""+obj+"\""; }
	if(type != "object") { return ""+obj; }
	
	//obj is an Array
	str = "";
	if(Object.prototype.toString.call(obj) === '[object Array]') {
		if(lvl > com.ibm.bpm.social.debug.NUM_LEVELS_OF_OBJECT_ATTRS_TO_LOG) {
			return "[...]";
		}
		for(i=0; i<obj.length; i++) {
			if(i >= com.ibm.bpm.social.debug.NUM_BREADTH_OF_OBJECT_ATTRS_TO_LOG) {
				str += ", ...";
				break;
			}
			if(i > 0) { str += ", "; }
			str += com.ibm.bpm.social.debug._stringReprOfObject(obj[i], lvl+1);
		}
		return "["+str+"]";
	}
	
	//obj is an Object
	objClass = "";
	try {
		objClass = ""+Object.prototype.toString.call(obj);
		objClass = objClass.substring("[Object ".length, objClass.length-"]".length);
	} catch(e) {}
	if(lvl > com.ibm.bpm.social.debug.NUM_LEVELS_OF_OBJECT_ATTRS_TO_LOG) {
		return objClass+"{...}";
	}
	numKeys = 0;
	for(key in obj) {
		if(obj.hasOwnProperty(key)) {
			if(numKeys >= com.ibm.bpm.social.debug.NUM_BREADTH_OF_OBJECT_ATTRS_TO_LOG) {
				str += ", ...";
				break;
			}
			str += (numKeys > 0 ? ", " : "")+key+"="+com.ibm.bpm.social.debug._stringReprOfObject(obj[key], lvl+1);
			numKeys++;
		}
	}
	return objClass+"{"+str+"}";
};
com.ibm.bpm.social.debug._mimicFirebugConsoleOutput = function(msg) {
	var args, c, i, type, replacementTypes;
	
	//get all the other arguments (not including the first)
	args = new Array();
	for(i=1; i<arguments.length; i++) {
		args.push(arguments[i]);
	}
	
	//if the first parameter isn't a string, just print out all args
	type = typeof(msg);
	if(type != "string") {
		msg = ""+(type=="object" ? com.ibm.bpm.social.debug._stringReprOfObject(msg) : msg);
		for(i=0; i<args.length; i++) {
			msg += " "+(typeof(args[i])=="object" ? com.ibm.bpm.social.debug._stringReprOfObject(args[i]) : args[i]);
		}
	}
	//if the first parameter is a string, we might have to handle
	// replacement characters (%s, %i, %o, etc)
	else {
		replacementTypes = new Array();
		i = msg.indexOf("%");
		while(i > -1) {
			if(i >= msg.length) { break; }
			if(/[A-Za-z]/.test(msg.charAt(i+1))) {
				replacementTypes.push(msg.charAt(i+1));
			}
			i = msg.indexOf("%", i+1);
		}
		for(i=0; i<args.length; i++) {
			//replace every %s, %i, %o, etc with the corresponding arg,
			// following Firebug's standards. if there aren't enough args
			// to satisfy the string, don't do any replacements
			if(args.length >= replacementTypes.length && replacementTypes.length > i) {
				c = replacementTypes[i];
				if(c !== "s" && c !== "d" && c !== "i" && c !== "f" && c !== "c") {
					msg = msg.replace("%"+c, com.ibm.bpm.social.debug._stringReprOfObject(args[i]));
				}
				else if(Object.prototype.toString.call(args[i]) === '[object Array]') { //if arg is Array
					msg = msg.replace("%"+c, com.ibm.bpm.social.debug._stringReprOfObject(args[i]));
				}
				else {
					msg = msg.replace("%"+c, (c == "c" ? "" : ""+args[i])); //%c is ignored
				}
			}
			else { //remaining args are just placed at the end
				msg += " "+(typeof(args[i]) == "object" ? com.ibm.bpm.social.debug._stringReprOfObject(args[i]) : args[i]);
			}
		}
	}
	
	return msg;
};
com.ibm.bpm.social.debug.getLogs = function() {
	return com.ibm.bpm.social.debug._logs;
};
com.ibm.bpm.social.debug.log = function(type, msg) {
	var msgObj = {'type':type, 'message':msg, 'date':(new Date())};
	com.ibm.bpm.social.debug._logs.push(msgObj);
	dojo.publish(com.ibm.bpm.social.debug.MESSAGE_LOGGED_TOPIC, [msgObj]);
};

//log all console methods
if(com.ibm.bpm.social.debug.isLogging && console) {
	//for browers other than IE, connect to the console functions
	if(!dojo.isIE) {
		dojo.connect(console, "log", null, function() {
			com.ibm.bpm.social.debug.log("log", com.ibm.bpm.social.debug._mimicFirebugConsoleOutput.apply(this, arguments));
		});
		dojo.connect(console, "info", null, function() {
			com.ibm.bpm.social.debug.log("info", com.ibm.bpm.social.debug._mimicFirebugConsoleOutput.apply(this, arguments));
		});
		dojo.connect(console, "warn", null, function() {
			com.ibm.bpm.social.debug.log("warn", com.ibm.bpm.social.debug._mimicFirebugConsoleOutput.apply(this, arguments));
		});
		dojo.connect(console, "debug", null, function() {
			com.ibm.bpm.social.debug.log("debug", com.ibm.bpm.social.debug._mimicFirebugConsoleOutput.apply(this, arguments));
		});
		dojo.connect(console, "error", null, function() {
			com.ibm.bpm.social.debug.log("error", com.ibm.bpm.social.debug._mimicFirebugConsoleOutput.apply(this, arguments));;
		});
	}
	
	//for IE, rebind the console functions entirely
	else {
		console.log = function() {
			com.ibm.bpm.social.debug.log("log", com.ibm.bpm.social.debug._mimicFirebugConsoleOutput.apply(this, arguments));
		};
		console.info = function() {
			com.ibm.bpm.social.debug.log("info", com.ibm.bpm.social.debug._mimicFirebugConsoleOutput.apply(this, arguments));
		};
		console.warn = function() {
			com.ibm.bpm.social.debug.log("warn", com.ibm.bpm.social.debug._mimicFirebugConsoleOutput.apply(this, arguments));
		};
		console.debug = function() {
			com.ibm.bpm.social.debug.log("debug", com.ibm.bpm.social.debug._mimicFirebugConsoleOutput.apply(this, arguments));
		};
		console.error = function() {
			com.ibm.bpm.social.debug.log("error", com.ibm.bpm.social.debug._mimicFirebugConsoleOutput.apply(this, arguments));
		};
	}
}
</script>

<script type="text/javascript">
document.write("<style>.ibmLayoutContainersHidden{position:absolute;top:-6000px;}</style>");
dojo.addOnLoad(function() {
	if(dojo.isSafari==5) {	//15689
		dojox.uuid.generateTimeBasedUuid = dojox.uuid.generateRandomUuid;
	}
});

ibmCfg = {};
ibmConfig = {};
</script>

<iframe src="/mum/js/bluedojo/161/dojo/resources/iframe_history.html" id="dj_history" name="dj_history" title="Page History" style="border:0;width:1px;height:1px;position:absolute;visibility:hidden;bottom:0;right:0;"></iframe>

<script type="text/javascript">
	dojo.registerModulePath('com.ibm.bspace', '/BusinessSpace/com/ibm/bspace');
</script>

<script src="/BusinessSpace/com/ibm/bspace/common/util/ui/bspacecommonui.js" type="text/javascript"></script>

<!--start theme.html content-->
<script type="text/javascript">
dojo.addOnLoad(function(){
     if(dojo.locale == 'he') {
	  dojo.addClass(dojo.query("#processPortalHelp")[0], "processPortalHebrewHelpIcon");
	}
	
	dojo.requireLocalization("com.ibm.bpm.social", "bpmSocial");
	processPortalMessages = dojo.i18n.getLocalization("com.ibm.bpm.social", "bpmSocial");
	
	com.ibm.bpm.calendarTypes={};
	com.ibm.bpm.calendarTypes['generalPreference.fields.calendarType.hebrew'] = processPortalMessages['generalPreference.fields.calendarType.hebrew'];
	com.ibm.bpm.calendarTypes['generalPreference.fields.calendarType.islamic'] = processPortalMessages['generalPreference.fields.calendarType.islamic'];
	com.ibm.bpm.calendarTypes['generalPreference.fields.calendarType.gregorian'] = processPortalMessages['generalPreference.fields.calendarType.gregorian'];

	com.ibm.bpm.baseTextDir={};
	com.ibm.bpm.baseTextDir['generalPreference.fields.baseTextDir.default'] = processPortalMessages['generalPreference.fields.baseTextDir.contextual']; // mawhidby - changed to default to contextual message instead of "do nothing"
	com.ibm.bpm.baseTextDir['generalPreference.fields.baseTextDir.ltr'] = processPortalMessages['generalPreference.fields.baseTextDir.ltr'];
	com.ibm.bpm.baseTextDir['generalPreference.fields.baseTextDir.rtl'] = processPortalMessages['generalPreference.fields.baseTextDir.rtl'];
});
</script>
<!--  BEGIN -- handle back/forward browser event (1/4) -->
<script type="text/javascript">
	// all functions and classes that start with "_" are expected only be used within the scope of this script node.
	
	dojo.require("dojo.back");
	var dojoBack = dojo.back;
	var dojoVersion = dojo.version;
	
	// following content is copied from IBM Coach: disableBack.js 
	// NOTICE: If you change anything here, please sync the change to disableBack.js of Coach.

	//*************** BEGIN ****************		
	var nextHashSuffix = "  ";
	
	_ApplicationState = function(stateData, bookmarkValue){
		this.stateData = stateData;
		this.changeUrl = bookmarkValue || false;
		
		this.back = function(){
			if(dojoVersion.major == 1 && dojoVersion.minor < 7) {
				// 1.6 or less
				setTimeout(function() {
					_generateHistory();
				}, 1);
			} else {
				// 1.7 or above
				_generateHistory();
			}
		};
		this.forward = function(){
			// do nothing for now. Since testing shows that forward button and menu item always disabled.
		}
	};
	
	function _generateHistory() {
		var baseHashValue = _getCurrentHash();
		var newHashValue = baseHashValue + nextHashSuffix;
		if(nextHashSuffix == " ") {
			nextHashSuffix = "  ";
		} else {
			nextHashSuffix = " ";
		}
		var appState = new _ApplicationState("Fake history", newHashValue);
		dojoBack.addToHistory(appState);
	}
	
	function _getCurrentHash() {
		var url = window.location;
		var hashValue = !!url.hash ? decodeURI(url.hash).substring(1) : "";
		
		var maxSpaces = "   "; // 3 spaces
		if(hashValue.length >= maxSpaces.length) {
			if(hashValue.substring(hashValue.length - maxSpaces.length) == maxSpaces) {
				// remove last few spaces
				hashValue = hashValue.substring(0, hashValue.length - maxSpaces.length);
			}
		} 
		return hashValue;
	}
	
	function initDisableBack() {
		var appState = new _ApplicationState("Initial state");				
		dojoBack.setInitialState(appState);
		
		// IE doesn't work properly if not to running following logic with a delay
		setTimeout(function() {
			_generateHistory();					
		}, 1000);
	}
	//*************** END ****************
	
	function handleHashChange() {
		setTimeout(function() {
			_generateHistory();
			
			setTimeout(function() {
				_generateHistory();					
			}, 1000);
		}, 1);
	}	
</script>
<!--  END -- handle back/forward browser event (1/4) -->

<script type="text/javascript">
     // Social Portal Global variables and functions initialization starts
	dojo.provide("com.ibm.bpm.socialportal.GlobalAssets");

	com.ibm.bpm.socialportal.GlobalAssets = {
			_environment: {
				rootUrl: window.location.protocol+"//"+window.location.hostname+":"+window.location.port,
				// hard-coding for now since we do not have any endpoint concept in Social Portal
				restContextRoot: "teamworks"
			},
			_userProfile: {
			},
			
			getEnvironment : function () {
				return this._environment;
			},
			
			setEnvironment : function (env) {
				this._environment = env;
			},
			
			getUserProfile : function () {
				return this._userProfile;
			},
			
			setUserProfile : function (userProfile) {
				this._userProfile = userProfile;
				dojo.publish("com.ibm.bpm.socialPortal.UserProfileChangedEvent", [{}]);
			},
			
			setUserPreference : function (key, value) {
			    var tempKey = encodeURIComponent(key);
			    var tempValue = encodeURIComponent(value);
			    var _key = key;
			    var _value = value;
				dojo.xhrPut({
					// somehow content does not work as url query param for PUT
					// user the embedded way for now
			        url: "/rest/bpm/wle/v1/user/current?action=setPreference&key="+tempKey+"&value="+tempValue,
			        handleAs: "json",
			        sync: true,
			        headers: {
			          "Content-Type": "application/json",
			          "Accept": "application/json"
			        },
			        load: function(data, xhrArgs){
			        	if (_key == 'Task Email Address') {
			        		com.ibm.bpm.socialportal.GlobalAssets._userProfile['emailAddress'] = _value;
			        		// Task email address is actually emailAddress from REST return
			        		com.ibm.bpm.socialportal.GlobalAssets._userProfile.userPreferences['Task Email Address'] = _value;
			        		
			        		//Reset the user avatar when the email changes, since this may affect Connections
			        		try{ com.ibm.bpm.social.util.common.Util.userAvatarURLs[com.ibm.bpm.socialportal.GlobalAssets._userProfile.userName] = null; } catch (e) {}
			        		try{ connectionsBridge.clearAvatarCache(com.ibm.bpm.socialportal.GlobalAssets._userProfile.emailAddress); } catch(e) {}
			        	} else {
			        		com.ibm.bpm.socialportal.GlobalAssets._userProfile.userPreferences[_key] = _value;
			        	}
						dojo.publish("com.ibm.bpm.socialPortal.UserProfileChangedEvent", [{}]);						
			        },
			        error: function(error) {
			        	// TODO: Use  UI error dialog to display instead of alert
			        	// TODO: Localize the error message
						alert("Error setting user preference: " + error);
			        }
			    });
				// TODO: Once REST API support multiple update we can have another helper to setUserPreferences([{key, value}])
			},
			//-------- BEGIN -- handle back/forward browser event (2/4)--------------------------
			locationHashChanged : function () {
				handleHashChange();
			}
			//--------- END --- handle back/forward browser event (2/4)--------------------------		

	};
	//--------- END --- handle back/forward browser event (2/4)--------------------------	
	dojo.mixin(com.ibm.bpm.socialportal.GlobalAssets, window.userProfile);

	// Social Portal Global variables and functions initialization ends
</script>

<script type="text/javascript">

	/** BSpace team needs to look at the layers here for prereqs **/
	dojo.require("dijit.form.Button"); //TODO Needs to be added to bspacecommonui prereqs

	/** Required for proper locale string handling **/
	dojo.require("dojo.date");	
	dojo.require("dojo.date.locale");
	dojo.require("dojo.date.stamp");
	dojo.require("dojo.number");
	/**	End **/
	
	//70603 - Need temporary failover from /bpmsocial or /portal to /ProcessPortal
	//ProcessPortalConfig
	var ppConfig = {
			portalContextRoot: "ProcessPortal",
			notificationContextRoot: "ProcessPortal/notification",
			webviewerContextRoot: "WebViewer"
	};
	
	dojo.config.isDebug = window.isDebug;
	if(dojo.config.isDebug){
		dojo.registerModulePath("org", "/"+ppConfig.notificationContextRoot+"/org");
		dojo.registerModulePath("dojox.cometd", "/"+ppConfig.notificationContextRoot+"/dojox/cometd");
		dojo.require("org.cometd");
		
		dojo.registerModulePath('com.ibm.bpm.social', '/'+ppConfig.portalContextRoot+'/com/ibm/bpm/social');
		dojo.require("com.ibm.bpm.social.portal.PageHandler");
		dojo.require("com.ibm.bpm.social.portal.WorkViewContainer");
		dojo.require("com.ibm.bpm.social.portal.DashboardController");
		dojo.require("com.ibm.bpm.social.portal.UserDropdown");
		dojo.require("com.ibm.bpm.social.widgets.debug.LoggingWidget");
		dojo.require("com.ibm.bpm.social.notifications"); // APAR JR45140 - Load if isDebug flag is set to true
	} else {
		
		//Get fingerprint version from server
		socialversion = 0;
		dojo.xhrGet({
			url: '/'+ppConfig.portalContextRoot+'/version.txt',
			preventCache: true,
			sync: true,
			load: function(data, xhrArgs){
				socialversion = data;
			}, 
			error: function(data, xhrArgs){
				//version.txt does not exist, do nothing at the moment
				socialversion = 0;
			}
		});
	
		//Load fingerprinted, cached layers
		dojo.registerModulePath('com.ibm.bpm', '/'+ppConfig.portalContextRoot+'/layers/'+socialversion+'/com/ibm/bpm');
		dojo.registerModulePath('com.ibm.bpm.social', '/'+ppConfig.portalContextRoot+'/layers/'+socialversion+'/com/ibm/bpm/social');
		dojo.registerModulePath('prereqs', '/'+ppConfig.portalContextRoot+'/layers/'+socialversion+'/prereqs');
		dojo.registerModulePath('org', '/'+ppConfig.portalContextRoot+'/layers/'+socialversion+'/org');

		//Standard loading of cached fingerprinted runtime layers
		dojo.require("prereqs.d3", true);
		dojo.require("org.cometd_base", true);
		dojo.require("com.ibm.bpm.social_base", true);
	}
	
</script>

<!--  Process Portal theme. Edit this for customization. -->
<link rel="stylesheet" type="text/css" href="/mum/mycontenthandler/mm/dav/filestore/public/themes/processPortalTheme/theme.css" />

<script type="text/javascript" src="/ProcessPortal/com/ibm/bpm/social/portal/system.js"></script>
<!-- <script type = "text/javascript" src ="/ProcessPortal/com/ibm/bpm/social/notifications.js"></script> --> <!-- APAR JR45140 - Build Layer already loads notifications.js-->

<script type="text/javascript">
dojo.addOnLoad(function(){

	//-------- BEGIN -- handle back/forward browser event (3/4)--------------------------
	initDisableBack();
	//--------- END --- handle back/forward browser event (3/4)--------------------------		
	try {	
		var userProfile =com.ibm.bpm.socialportal.GlobalAssets.getUserProfile();
		document.getElementById('processPortalUserName').innerHTML= userProfile['fullName'];
		
        //configure BTD for user full name
        com.ibm.bpm.social.util.baseTextDirection.BidiTextBox.setElementBTD(document.getElementById('processPortalUserName'));
		
		dojo.subscribe("com.ibm.bpm.socialPortal.UserProfileChangedEvent", function(args){
			var profile = com.ibm.bpm.socialportal.GlobalAssets._userProfile;
			com.ibm.bpm.social.util.common.Util.currentUser = profile;
			com.ibm.bpm.social.util.common.Util.userData[profile.userName] = profile;
		 });
	} catch(e) {
		// Update server with the new default values
		for (var property in window.defaultValuesToBeUpdated) {
			com.ibm.bpm.socialportal.GlobalAssets.setUserPreference(property, window.defaultValuesToBeUpdated[property]);
		}	
	}
	
	if (typeof(dojoConfig)=="undefined") {
		dojoConfig = {
			parseOnLoad: true,
			isDebug: false
		};
	}
	
	var connUrl = com.ibm.bpm.social.util.common.Util.getConnectionsURL();
	if(typeof(connUrl)!="undefined" && connUrl!=""){
		dojo.require("com.ibm.bpm.social.util.connections.ConnectionsBridge");
		connectionsBridge = new com.ibm.bpm.social.util.connections.ConnectionsBridge();
		connectionsBridge.onLoad(connUrl);
	
	}
	
	var stUrl =  com.ibm.bpm.social.util.common.Util.getSametimeURL();
	if(typeof(stUrl)!="undefined" && stUrl!=""){
		/* sametime init */
		stproxyConfig = {
				server: stUrl,
				tunnelURI: document.location.protocol+"//"+document.location.host+"/"+ppConfig.portalContextRoot+"/js/tunnel-852.html",
				plugins: {
					lnmpMeetingInvite: false,
					lnmpSendAnnouncement: false
				}
		};
	
		dojo.require("com.ibm.bpm.social.util.sametime.SametimeBridge");
		sametimeBridge = new com.ibm.bpm.social.util.sametime.SametimeBridge();
		sametimeBridge.onLoad();
	
		sametimeBridge.loginByShortname(com.ibm.bpm.socialportal.GlobalAssets.getUserProfile().userName);
	}
	
	//add cross-site scripting listeners for the dashboards page
	var onMessage = function(evt) {
		var msg = evt.data;
		var origin = evt.origin;
		if (typeof msg === "string") {
			if(msg.indexOf("displayInstanceDetails: ")==0) {
				var instanceId = parseInt(msg.substring("displayInstanceDetails: ".length, msg.length));
				com.ibm.bpm.social.portal.PageHandler.getInstance().displayInstanceDetails(instanceId);
			}
			else if(msg.indexOf("showTaskCompletion: ")==0) {
				var taskId = parseInt(msg.substring("showTaskCompletion: ".length, msg.length));
				com.ibm.bpm.social.portal.PageHandler.getInstance().showTaskCompletion(taskId);
			} else {			
				var payloadLiteral = evt.data;
				var origin = evt.origin;
				var payload = dojo.fromJson(payloadLiteral);
				if(typeof payload["resizeDashboardIframe"] != 'undefined') {
					var height = payload["resizeDashboardIframe"];
					resizeDashboardIframe(height);	
				} else if (typeof payload["name"] != 'undefined') {
					var eventType = payload["name"];
					var taskID = payload["taskID"];
					var firstParameter = null;
					if (payload.parameters && payload.parameters.length > 0 && typeof payload.parameters[0] === "string") {
					  if (payload.parameters[0].length > 0) {
						firstParameter = payload.parameters[0];
					  }
					}
					if  (eventType == "onInitialized") {
						// do we want to resize iFrame?
						var scoreboardFrameVar = document.getElementById("scoreboardFrame");
						if (scoreboardFrameVar) {
							if (firstParameter == null || firstParameter !== "oldCoach") {
								resizeDashboardIframe(220);
							}
						}
					} else if  (eventType == "onCompleted" && taskID) {
						// if the service was launched by dashboard menu, then show completed message;
						// only do this if taskID exists
						// We also do this by checking if the dashboards page is what's currently 
						// being shown to the user
						var dashboardPageDiv = dojo.byId("dashboardPageDiv");
						if(dojo.hasClass(dashboardPageDiv, "processPortalSelectedPage")) {
							var scoreboardFrameVar = document.getElementById("scoreboardFrame");
							if (scoreboardFrameVar) {
								if (firstParameter == null || firstParameter !== "oldCoach") {
	                                var finalSrc = '/'+ppConfig.portalContextRoot+'/jsp/socialPortal/dashboard_restart.jsp?portalcontextroot='+escape(ppConfig.portalContextRoot);
									dojo.attr(scoreboardFrameVar, "src", finalSrc);
								}
							}
						}
					} else if (eventType == "onDashboardRestart") {
                        var scoreboardFrameVar = document.getElementById("scoreboardFrame");
                        dojo.publish(com.ibm.bpm.social.portal.Topics.SHOW_DASHBOARD, [{
                          runURL: "RESTART_DASHBOARD",
                          display: "RESTART_DASHBOARD"
                        }]);
                    }
				} else if (typeof payload["criticalPathFlows"] != 'undefined') {
					var criticalPathFlows = payload["criticalPathFlows"]; // array
					var instanceId = payload["instanceId"];
					dojo.publish(com.ibm.bpm.social.portal.Topics.OPEN_PROCESS_DIAGRAM, [ { "instanceId": instanceId, "criticalPathFlowIds": criticalPathFlows } ]);
				}
			}
		}
	}
	if(typeof window.addEventListener != 'undefined') {
		window.addEventListener('message', onMessage, false);
	}
	else if(typeof window.attachEvent != 'undefined') {
		window.attachEvent('onmessage', onMessage);
	}
});
</script>

<!-- Framekiller code -->
<script>
	//only run if enableRunInFrame is false
	if(!<%=enableRunInFrame%>) {
	if (self == top) {
		document.documentElement.style.display = 'block';
	} else {
		top.location = self.location;
		}
	}
</script>


</head>
<body class="processPortal">
<!--  BEGIN -- handle back/forward browser event (4/4), must put this part at very begining of body -->
	<script type="text/javascript">
		dojo.back.init();
	</script>
<!--  END ---- handle back/forward browser event (4/4) -->
<% if(isLogging.equals("true")) { %>
<div data-dojo-type="com.ibm.bpm.social.widgets.debug.LoggingWidget"></div>
<% } %>

<!--  Process Portal banner -->
<div id="com.ibm.bpm.processPortalBanner" class="processPortalBanner" onclick="com.ibm.bpm.social.portal.PageHandler.getInstance().hideDashboardDropdown(event);" href="javascript:" role="banner">
	<div id="messageNotificationDiv"></div>
	<div id="processPortalNavigation" class="processPortalNavigation">
			<div class="processPortalLogo">
                <span class="processPortalIconA11y">IBM</span>
            </div>
			<div id="processPortalWorkTab" class="processPortalTab processPortalSelectedTab" data-page="workPageDiv" data-widget="workPage">
				<div class="processPortalWorkTabIcon"></div>
				<div class="processPortalWorkTabText"><a id="processPortalWorkLink" onclick="return com.ibm.bpm.social.portal.PageHandler.getInstance().selectWorkTab();" href="javascript:void(0);"></a></div>
			</div>
			<div id="processPortalDashboardTab" class="processPortalTab" data-page="dashboardPageDiv" data-widget="dashboardPage">
				<div class="processPortalDashboardTabIcon"></div>
				<div class="processPortalDashboardTabText" id="processPortalDashboardTabDropDownId">
                    <a id="processPortalDashboardsLink" onclick="return com.ibm.bpm.social.portal.PageHandler.getInstance().onDashboardDropdownClick(event);" href="javascript:void(0);">
                        <img src="/mum/mycontenthandler/mm/dav/filestore/public/themes/processPortalTheme/img/white_drop_down.png" alt="" id="processPortalDashboardTabDropDownImg"/> 
                    </a>
                </div>
			</div>
	</div>
	<div id="processPortalFullScreenCoach" class="processPortalFullScreenCoach" style="display:none">
			<div class="processPortalLogo"></div>
			<div class="processPortalFullScreenCoachTitle">
				<span id="processPortalFullScreenCoachSubject" class="processPortalFullScreenCoachTitle"></span>
			</div>
			<div id="processPortalFullScreenCoachDue" class="processPortalFullScreenCoachTitle">
				<span class="processPortalFullScreenCoachTitle">|</span>
				<span id="processPortalFullScreenCoachDueLabel" class="processPortalFullScreenCoachTitle processPortalFullScreenCoachDue"></span>
				<span id="processPortalFullScreenCoachDueDate" class="processPortalFullScreenCoachTitle processPortalFullScreenCoachDue processPortalFullScreenCoachDueDate"></span>
			</div>
			<div id="processPortalFullScreenCoachIcon" class="processPortalFullScreenCoachIcon bpm-social-collapse-full-screen" tabIndex="0" >
				<span id="processPortalFullScreenCoachIconA11y" class="bpm-social-a11y"></span>
			</div>
	</div>
	<div id="processPortalCollaborationBanner"></div>
	<div id="processPortalUser" class="processPortalUser">
		<div class="processPortalUserArea">
			<div id="processPortalUserAreaRtl" class="processPortalUserAreaRtl" style="display: none;"></div>
			<a role="link" id="processPortalUserDropdownId" class="processPortalUserDropdownId" href="javascript:void(0);" onclick="showUserDropdown(event); return false;">
				<span id="processPortalUserName" class="processPortalUserName"></span>
				<div id="processPortalUserDropdown" class="processPortalUserDropdown"></div>
                <div id="processPortalUserDropdownA11y" class="processPortalUserDropdownA11y">&#9660;</div>
			</a>
			<a id="processPortalGoToSpacesLink" class="processPortalGoToSpacesLink" href="javascript:void(0);" onclick="showGoToSpaces(event); return false;"></a>
			<a id="processPortalHelp" class="processPortalHelpIcon" href="/BusinessSpaceHelp/index.jsp?topic=/com.ibm.wbpm.portal.help.doc/topics/cparticipating_intro.html" target="_blank"></a>
		</div>
	</div>
  </div>
  <div id="processPortalContent"  href="javascript:void(0);" role="main">
		<div id="workPageDiv" class="processPortalPage processPortalSelectedPage" data-loaded="false">
			<div id="workPage" dojoAttachPoint="workPage" dojoType="dijit.layout.ContentPane" style="width:100%; height:100%; float:left;" preload="true"></div> 
		</div>

		<div id="processPageDiv" class="processPortalPage processPortalNonSelectedPage" data-loaded="false">
		<%-- ASZ: didn't find any class/method using this. However, there's an RPT violation with the ContentPanee. So just removing the ContentPanee for now 
			<div id="processPage" dojoAttachPoint="processPage" dojoType="dijit.layout.ContentPane" style="width:100%; height:100%; float:left;" preload="true"></div>
		--%> 		
			<div id="processPage" dojoAttachPoint="processPage"  style="width:100%; height:100%; float:left;" preload="true"></div> 		
		</div>
		<div id="dashboardPageDiv" class="processPortalPage processPortalNonSelectedPage" data-loaded="false">
			<div id="dashboardPage" dojoAttachPoint="dashboardPage" dojoType="com.ibm.bpm.social.portal.DashboardController" style="width:100%; float:left;" preload="true"></div> 
		</div>
  </div>   	    	   	
</body>
</html>
