<%@ page language="java" pageEncoding="UTF-8" contentType="text/html; charset=UTF-8" session="false" %>
<%@ page import="com.lombardisoftware.utility.env.ResourceEnvironmentUtils" %>
<%@ page import="java.util.logging.Level" %>
<%@ page import="java.util.logging.Logger" %>
<%@ page import="java.util.Map" %>

<%!
	final String FILE_NAME = "login.jsp";
	final Logger log = Logger.getLogger(FILE_NAME);
%>
<%
/*
Login customization properties are stored in WebSphere Resource Environment Provider named Mashups_ConfigService
*/

ResourceEnvironmentUtils utils = new ResourceEnvironmentUtils();

String productName = null;
String loginStyle = null;
String enableRunInFrame = null;
Map<String, String> props = null;

try {
	props = utils.getProperties("Mashups_ConfigService", "[com.ibm.mashups.productname,com.ibm.bspace.login.style,com.ibm.bpm.social.enableRunInFrame]");
} catch (Exception e) {
	log.log(Level.SEVERE, "Exception Encountered from ResourceEnvironmentUtils", e);
}
if(props != null) {
	productName = props.get("com.ibm.mashups.productname");
	loginStyle = props.get("com.ibm.bspace.login.style");
	enableRunInFrame = props.get("com.ibm.bpm.social.enableRunInFrame");
}
if(productName == null || productName.equals("NULL")) {
	productName = "Process Portal";
}
if(loginStyle == null  || loginStyle.equals("NULL")) {
	loginStyle = "bspace";
}
if(enableRunInFrame == null || enableRunInFrame.equals("NULL")) {
	enableRunInFrame = "false";
}
%>
<html>
<head>
	<meta http-equiv="X-UA-Compatible" content="IE=9; IE=8" />
    <title>IBM Process Portal</title>
    <link rel="stylesheet" type="text/css" href="/mum/contenthandler/mm/dav/filestore/login/bspace/login.css" media="screen, projection" />
    <!-- Framekiller code -->
	<script>
		//only run if enableRunInFrame is set to false
		if(!<%=enableRunInFrame%>) {
		if (self == top) {
			document.documentElement.style.display = 'block';
		} else {
			top.location = self.location;
			}
		}
	</script>
	<script type="text/javascript" src="/mum/js/bluedojo/161/dojo/dojo.js" charset="UTF-8"></script>
    <script>
        function setCookie(name, value, expires, path, domain, secure) {
            var curCookie = name + "=" + escape(value) +
                    ((expires) ? "; expires=" + expires.toGMTString() : "") +
                    ((path) ? "; path=" + path : "") +
                    ((domain) ? "; domain=" + domain : "") +
                    ((secure) ? "; secure" : "");
            document.cookie = curCookie;
        }

        function doOnSubmit() {
        <%--We want to make sure the applet has been loaded before we log in so that we can get the correct locale/time zone info from the client. If all else fails we assume GMT...--%>
            try {
                setCookie("ibm.bpm.timezoneOffset", new Date().getTimezoneOffset(), null, "/",null,<% if(request.isSecure()){%>true<%}else{%>null<%}%>);
            } catch(ex) {
                //do nothing
            }
            return true;
        }
		
		function nlsFix(id) {
			var e = document.getElementById(id);
			if (e) {
				var msg_txt;
				// the field with id 'password_label' needs to use the message called 'password' 
				if (id == 'password_label') msg_txt = messages['password']; 
				else msg_txt = messages[id];
				if (e.nodeName == 'INPUT') {
					e.value = msg_txt;
				} else {
					e.appendChild(document.createTextNode(msg_txt));
				}
			}
		} 

		function loadCssFile(css) {
			var link = document.createElement('link');
			link.rel = 'stylesheet';
			link.href = css;
			link.type = 'text/css';
			link.media = 'screen';
			link.charset = 'utf-8';
			document.getElementsByTagName('head')[0].appendChild(link);
		}		
		
		function checkForHash() {
			var url = window.location.href;
			if (url.indexOf('#') != -1) {
				var hash = url.substring(url.indexOf('#')+1);
				dojo.cookie("com_ibm_bpm_process_portal_hash", hash, {path: "/"});
			}
		}
		
	dojo.registerModulePath("com.ibm.bspace.common.util.ui", "/BusinessSpace/com/ibm/bspace/common/util/ui");
	dojo.require("dojo.i18n");
	dojo.require('com.ibm.bspace.common.util.ui.bspacecommonui');
	dojo.require('com.ibm.bspace.common.util.ui.Helper');
	dojo.require('com.ibm.bspace.common.util.ui.ComboBox');
	dojo.require('com.ibm.bspace.common.util.ui.FilteringSelect');
	
	// Defect 64103
	dojo.require("dojo.cookie");
	var tempPastDate = new Date();
	tempPastDate.getHours() - 2;	
	dojo.cookie("com_ibm_bpm_bspace_logout", null, {expires: -1, path: "/mum/"});
	
	dojo.require("dojo.hash");
	<% if (request.getParameter("errorMessage") != null)  { %>
	var lastHash = dojo.cookie("com_ibm_bpm_process_portal_hash");
	if (lastHash) {
		dojo.hash(lastHash);
	}
	<% } %>
	dojo.cookie("com_ibm_bpm_process_portal_hash", null, {path: "/"});


    var locale = "<%=request.getLocale().toString().toLowerCase().replace('_','-')%>";
    var messages = null;
    try {
        dojo.registerModulePath("banner","/BusinessSpace/login");
        dojo.requireLocalization("banner","bannerResourcesMinimal",locale,"ar,cs,de,el,es,fr,he,hu,it,iw,ja,ko,pl,pt,pt-br,ro,ru,tr,zh,zh-tw,da,fi,nb,sk,sv,nl,no");
        messages = dojo.i18n.getLocalization("banner","bannerResourcesMinimal",locale);
        if ((locale.length > 2) && (locale.charAt(2) == '-')) {
            locale = locale.substring(0,2) + '_' + locale.substring(3).toUpperCase(); 
        }
    	document.documentElement.setAttribute('lang',locale);
    	document.documentElement.setAttribute('xml:lang',locale);
        var loc = locale.substring(0,2);
    	if ((loc == 'ar') || (loc == 'iw') || (loc == 'he')) {
    		document.body.setAttribute('dir','rtl');
    	}
    } catch (ex) {
        // localization failed!!!! what can/should we do now
        console.log("Error loading locale specific text.");
        messages = { welcome:			"Welcome! Enter your information",
			         user_id:			"User ID :",
		        	 password:			"Password :",
					 log_in:			"Log in",
		        	 username_required:	"Username is required",
		        	 password_required:	"Password is required",
		        	 returnToLastPage: 	"Manage Business Spaces",
		        	 copyrights:        "Licensed Materials - Property of IBM. \u00A9 Copyright 2008, 2013 IBM Corporation.  IBM, the IBM logo, and WebSphere are trademarks of IBM Corporation, registered in many jurisdictions worldwide.  Other product and service names might be trademarks of IBM or other companies."};
    }
	
	
	window.document.title = "<%=productName%>";
	window.loginStyle = "<%=loginStyle%>";
	console.debug(" window.loginStyle = " + window.loginStyle);
	console.debug(" window.document.title = " + window.document.title);
	
    </script>
</head>
<body scroll='no' onLoad="" style="height:100%; width:100%; margin: 0px"  id="login" class="processPortal">
<div class="login_background_image">
			<form id="loginForm" name="login-form" method="post" action="<%= response.encodeURL("j_security_check") %>" onSubmit="checkForHash()">
				<div class="login_content" role="main" aria-label="BPM Process Portal login">
					<div class="login_header" >
						<div class="login_ibm_logo"><img src="/mum/contenthandler/mm/dav/filestore/login/bspace/images/login_logo.png" width="180" height="105" alt="IBM logo"/></div>
						<div class="BPM_process_portal_text">BPM  |   Process Portal</div>
					</div>
					<div class="popup_window">
					<div class="login_window_content">
						<%String msgKey = request.getParameter("errorMessage");%>
						<%if(msgKey != null) {%>
						<div id="loginFailedMessage"></div>
						<%} else {%>
						<div id="loginFailedMessage" style="display:none;"></div>							
						<%}%>
						<div class="login_username_field">
							<label for="username" class="loginText" id="user_id"></label>
							<input id="username" class="login-field" type="text" name="j_username" autocapitalize="off" />
						</div>
						<div class="login_password_field">
							<label for="password" class="loginText" id="password_label"></label>
							<input name="j_password" id="password" type="password" class="login-field" autocomplete="off"></input>
						</div>
						<input id="log_in" class="btn" type="submit" name="save" value=""></input>
					</div>
				</div>
				<div class="legal_text">
					<p id="copyrights" class="legal_text" role="contentinfo"></p>
				</div>				
			</form>	
			<table cellpadding="0" cellspacing="0">
			<tbody>
				<tr id="CRspacer" valign="top">
					<td>
						<img src="/BusinessSpace/login/images/blank.gif" width="33" height="1" alt=""/>
					</td>
					<td id="spacer"> 
					</td>
					<!-- d104158: The following td element is a dummy one just to honor the variables used from inside login_footer.jsp -->
					<td>
						<!-- Defect 47448: APAR JR30897 -->
						<!-- enclose mashups msgs in a hidden div so they are never shown -->
						<div style="display:none">
							<div id="signErrorDiv" style="color: red; display: inline; width: 435px; display: none;"></div>
							<div id="signErrorMsg" style="display: none;"></div>
						</div>
					</td>
				</tr>
				<tr id="CRspacer2" valign="top">
					<td>
						<img src="/BusinessSpace/login/images/blank.gif" width="33" height="1" alt=""/>
					</td>
				</tr>				
			</tbody>
			</table>
		</div>
	</div>
	</body>
</html>

<!-- BS scripts - start -->

<script type="text/javascript">
	var spacer = document.getElementById('CRspacer');
	var spacerUnsecure = document.getElementById('CRspacerUnsecure');
	var spacer2 = document.getElementById('spacer2');
       	
		if (dojo.isIE)
		{
			if (spacer != null)
	       		spacer.style.height = '1px';
       		
			if (spacerUnsecure != null)
	       		spacerUnsecure.style.height = '70px';

			if (spacer2 != null)
		       	spacer2.style.height = '15px';       		
		}
	    else
	    {
			if (spacer != null)
		       	spacer.style.height = '1px';

			if (spacerUnsecure != null)
				spacerUnsecure.style.height = '90px';
	    }

   	nlsFix('welcome');
	nlsFix('user_id');
	nlsFix('password_label');
	nlsFix('log_in');
	nlsFix('copyrights');
	<% 
	   if (com.ibm.mm.framework.Platform.getInstance().isSecurityEnabled()) 
	   {
	%>	
		var loginFailedMessage = document.getElementById('loginFailedMessage');
		loginFailedMessage.appendChild(document.createTextNode(messages.login_error));
		loginFailedMessage.setAttribute("aria-label", messages.login_error);
		loginFailedMessage.setAttribute("role", "alert");
        loginFailedMessage.setAttribute("aria-live", "assertive");
		loginFailedMessage.style.fontFamily = 'Arial, Verdana';
		loginFailedMessage.style.fontSize = '11px';
<%
	   }
%>
	
	com.ibm.bspace.common.util.ui.Helper.loadStyleSheet();
	com.ibm.bspace.common.util.ui.Helper.wrapElement(document.getElementById('username'));
	com.ibm.bspace.common.util.ui.Helper.wrapElement(document.getElementById('password'));
	com.ibm.bspace.common.util.ui.Helper.wrapElement(document.getElementById('log_in'));

	document.getElementById('username').focus();
	
	// Fix ie6 focus problem
	if(dojo.isIE)
	{	
		setTimeout(
			function()
			{
				var username_field = document.getElementById('username');
				username_field.focus();
				username_field.select();
			}
		, 1);
	}

	// Load the CSS and icon from the folder specified in the com.ibm.bspace.login.style location if it is provided and not the default of "bspace"
	var bspaceLoginStyle = window.loginStyle;
	if (bspaceLoginStyle == "null" || bspaceLoginStyle == "bspace"){
		document.write('<link rel="icon" href="/mum/contenthandler/mm/dav/filestore/login/bspace/images/portal.ico" type="image/x-icon"/>');
	}
	else {
		loadCssFile("/mum/contenthandler/mm/dav/filestore/login/" + bspaceLoginStyle + "/login.css");
		document.write('<link rel="icon" href="/mum/contenthandler/mm/dav/filestore/login/' + bspaceLoginStyle + '/images/portal.ico" type="image/x-icon"/>');
	}
</script>